image: tmaier/docker-compose:latest

variables:
  GIT_SUBMODULE_STRATEGY: recursive

services:
  - docker:dind

stages:
        - build
        - test
        - deploy
before_script:
        - apk --no-cache add git
        - git submodule sync --recursive
        - git submodule update --init --recursive
        - whoami
        - docker info
        - docker-compose --version
        - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
buildCompose:
        stage: build
        script:
                - echo "Building..."
                - docker-compose build
                - docker-compose push

runTestScript:
        stage: test
        script:
                - echo "Testing..."
                - ./runtests.sh

deployToCloud:
        stage: deploy
        script:
                - echo "Deploying..."
                - apk add --no-cache sshpass rsync openssh-client
                - sshpass -p "$PROD_SSH_PASSWD" rsync -avzh -e 'ssh -o StrictHostKeyChecking=no -p 22' ./docker-compose.yml $PROD_SSH_USER@$PROD_SSH_IP:~/docker-compose.yml
                - sshpass -p "$PROD_SSH_PASSWD" ssh -o StrictHostKeyChecking=no $PROD_SSH_USER@$PROD_SSH_IP "sudo docker pull mymobiconf/authservice && sudo docker pull mymobiconf/cassandra-migration"
                - sshpass -p "$PROD_SSH_PASSWD" ssh -o StrictHostKeyChecking=no $PROD_SSH_USER@$PROD_SSH_IP "sudo docker stack deploy -c docker-compose.yml authservice"
